#include <iostream>
using namespace std;

bool brisanjeNajviseJednog(int *niz, int len, int l, int r) {
  bool v = true;
  int br = 0;
  if (len == 3 || r - l == 2)
    if (niz[l - 1] > niz[l] && niz[l] > niz[l + 1])
      v = false;
  if (len > 3 && r - 2 > l)
    for (int i = l + 1; i < r; i++) {
      if (niz[i] < niz[i - 1] || niz[i] < niz[i - 2])
        br++;
      if (br > 1) {
        v = false;
        break;
      }
    }
  return v;
}

int main() {
  int N;
  cin >> N;
  int glavni[N];
  for (int i = 0; i < N; i++)
    cin >> glavni[i];
  int Q;
  cin >> Q;
  int l[Q];
  int r[Q];
  for (int i = 0; i < Q; i++)
    cin >> l[i] >> r[i];
  for (int i = 0; i < Q; i++) {
    if (brisanjeNajviseJednog(glavni, N, l[i], r[i]))
      cout << "DA" << endl;
    else
      cout << "NE" << endl;
  }
}